## ggml 0.0~git20250502.17733de

=== debian/changelog ===
ggml (0.0~git20250502.17733de-3) unstable; urgency=medium

  * Amend missing build profile in HIP B-D
  * Add patches enabling installation of tests
  * Convert libggml from arch:all to arch:any
  * Ship upstream tests, add autopkgtests
  * Tighten inter-package dependencies
  * Add ggml-cuda's d/changelog.cuda
  * Add comment on ggml-cuda to d/copyright
  * Enable Salsa CI

 -- Christian Kastner <ckk@debian.org>  Mon, 09 Jun 2025 20:54:26 +0200

ggml (0.0~git20250502.17733de-2) unstable; urgency=medium

  * Implement CUDA build, based on Mo Zhou's approach

 -- Christian Kastner <ckk@debian.org>  Mon, 12 May 2025 23:38:33 +0200

ggml (0.0~git20250502.17733de-1) unstable; urgency=medium

  * Upload to unstable.

  * New upstream version 0.0~git20250502.17733de
    - Drop cmake-Make-SSE4.2-optional.patch
  * Update d/copyright pattern
  * Add Build-Profile pkg.ggml.nohip to skip HIP build

 -- Christian Kastner <ckk@debian.org>  Fri, 09 May 2025 08:35:26 +0200

ggml (0.0~git20250414.be935ac-5) experimental; urgency=medium

  * Limit HIP B-D to amd64 arm64 ppc64el.
    Needed by libggml-hip which is already limited to these architectures,
    so this was just an oversight.

 -- Christian Kastner <ckk@debian.org>  Mon, 21 Apr 2025 17:02:07 +0200

ggml (0.0~git20250414.be935ac-4) experimental; urgency=medium

  * Initial release (Closes: #1096105)

 -- Christian Kastner <ckk@debian.org>  Fri, 18 Apr 2025 16:53:25 +0200
