=== debian/control ===
Source: ggml
Section: science
Priority: optional
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Christian Kastner <ckk@debian.org>
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/deeplearning-team/ggml
Vcs-Git: https://salsa.debian.org/deeplearning-team/ggml.git
Homepage: https://github.com/ggml-org/ggml
Build-Depends: cmake,
               debhelper-compat (= 13),
               hipcc [amd64 arm64 ppc64el] <!pkg.ggml.nohip>,
               libblas-dev,
               libhipblas-dev [amd64 arm64 ppc64el] <!pkg.ggml.nohip>,
               librocblas-dev [amd64 arm64 ppc64el] <!pkg.ggml.nohip>,
               pkgconf,
               libvulkan-dev,
               glslc,
Rules-Requires-Root: no

Package: libggml
Architecture: any
Multi-Arch: same
Depends: libggml-cpu | libggml-backend,
         ${misc:Depends},
Description: Tensor library for machine learning
 ggml is a tensor library for machine learning with the following features:
 .
  * Low-level cross-platform implementation
  * Integer quantization support
  * Broad hardware support
  * Automatic differentiation
  * ADAM and L-BFGS optimizers
  * No third-party dependencies
  * Zero memory allocations during runtime
 .
 Note that ggml is not yet stable, so its files are installed to private
 directories for now, and there is no dedicated -dev package yet.
 .
 On Debian, ggml is shipped as a package that depends on one of the CPU or
 GPU backends.
 .
 This package provides the main library, development files, and tests.

Package: libggml-cpu
Architecture: any
Multi-Arch: same
Depends: libggml (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Provides: libggml-backend
Conflicts: libggml-backend
Description: Tensor library for machine learning - CPU backend
 ggml is a tensor library for machine learning with the following features:
 .
  * Low-level cross-platform implementation
  * Integer quantization support
  * Broad hardware support
  * Automatic differentiation
  * ADAM and L-BFGS optimizers
  * No third-party dependencies
  * Zero memory allocations during runtime
 .
 Note that ggml is not yet stable, so its files are installed to private
 directories for now, and there is no dedicated -dev package yet.
 .
 On Debian, ggml is shipped as a package that depends on one of the CPU or
 GPU backends.
 .
 This package provides the CPU backend.

Package: libggml-blas
Architecture: any
Multi-Arch: same
Depends: libggml (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: libopenblas0 | libblis4 | libmkl-rt | libblas3
Provides: libggml-backend
Conflicts: libggml-backend
Description: Tensor library for machine learning - BLAS backend
 ggml is a tensor library for machine learning with the following features:
 .
  * Low-level cross-platform implementation
  * Integer quantization support
  * Broad hardware support
  * Automatic differentiation
  * ADAM and L-BFGS optimizers
  * No third-party dependencies
  * Zero memory allocations during runtime
 .
 Note that ggml is not yet stable, so its files are installed to private
 directories for now, and there is no dedicated -dev package yet.
 .
 On Debian, ggml is shipped as a package that depends on one of the CPU or
 GPU backends.
 .
 This package provides the BLAS backend.

Package: libggml-hip
Architecture: amd64 arm64 ppc64el
Multi-Arch: same
Depends: libggml (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Provides: libggml-backend
Conflicts: libggml-backend
Build-Profiles: <!pkg.ggml.nohip>
Description: Tensor library for machine learning - HIP backend
 ggml is a tensor library for machine learning with the following features:
 .
  * Low-level cross-platform implementation
  * Integer quantization support
  * Broad hardware support
  * Automatic differentiation
  * ADAM and L-BFGS optimizers
  * No third-party dependencies
  * Zero memory allocations during runtime
 .
 Note that ggml is not yet stable, so its files are installed to private
 directories for now, and there is no dedicated -dev package yet.
 .
 On Debian, ggml is shipped as a package that depends on one of the CPU or
 GPU backends.
 .
 This package provides the HIP backend, for AMD GPUs.

Package: libggml-vulkan
Architecture: any
Multi-Arch: same
Depends: libggml (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Provides: libggml-backend
Conflicts: libggml-backend
Description: Tensor library for machine learning - Vulkan backend
 ggml is a tensor library for machine learning with the following features:
 .
  * Low-level cross-platform implementation
  * Integer quantization support
  * Broad hardware support
  * Automatic differentiation
  * ADAM and L-BFGS optimizers
  * No third-party dependencies
  * Zero memory allocations during runtime
 .
 Note that ggml is not yet stable, so its files are installed to private
 directories for now, and there is no dedicated -dev package yet.
 .
 On Debian, ggml is shipped as a package that depends on one of the CPU or
 GPU backends.
 .
 This package provides the Vulkan backend.
