=== debian/tests/control ===
Test-Command: /usr/libexec/ggml/runtests
Features: test-name=libggml-cpu
Depends: libggml-cpu
Restrictions: skippable, allow-stderr

Test-Command: /usr/libexec/ggml/runtests
Features: test-name=libggml-cpu
Depends: libggml-blas, libopenblas0-pthread
Restrictions: skippable, allow-stderr

Test-Command: rocm-test-launcher /usr/libexec/ggml/runtests
Features: test-name=libggml-hip
Depends: libggml-hip, pkg-rocm-tools
Restrictions: skippable, allow-stderr
Architecture: amd64 arm64 ppc64el
